package com.infravio.service;

import javax.xml.stream.XMLStreamException;

import org.apache.axis2.om.OMElement;
import org.apache.axis2.om.OMFactory;
import org.apache.axis2.om.OMAbstractFactory;
import org.apache.axis2.om.OMNamespace;

/* Sample SOAP request to invoke calculator1 Webservice using Jmeter or tcpmon utilities.

SOAPAction: ""

<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">
    <soapenv:Header></soapenv:Header>
    <soapenv:Body>
        <add:add xmlns:add="http://infravio.com/infravioapi" add:echo="7" add:echo1="3">
        </add:add>
    </soapenv:Body>
</soapenv:Envelope>

*/


public class calculator1 {

    /* Method Addition , Takens in a OMElement of this format
     */
    public OMElement addition(OMElement element) throws XMLStreamException {
      //Praparing the OMElement so that it can be attached to another OM Tree.
      //First the OMElement should be completely build in case it is not fully built and still
      //some of the xml is in the stream.
      element.build();
      element.detach();
      java.util.Iterator  iter = element.getAttributes();
      double sum = 0;
      while(iter.hasNext()) {
        org.apache.axis2.om.OMAttribute attribute = (org.apache.axis2.om.OMAttribute)iter.next();
        double temp = Double.parseDouble(attribute.getValue().trim());
        sum+=temp;
      //element.removeAttribute(attribute);
      }
      System.out.println(" Addition result "+sum+"  to element "+element.getNamespace().getName());
      element.setText(sum+"");

      return element;
    }
    /* Method Subtraction  ,Takens in OMElement of this format
     */
    public OMElement subtraction(OMElement element) throws XMLStreamException {
      //Praparing the OMElement so that it can be attached to another OM Tree.
      //First the OMElement should be completely build in case it is not fully built and still
      //some of the xml is in the stream.
      element.build();
      element.detach();
      java.util.Iterator  iter = element.getAttributes();
      double sub = -1;
      java.util.Vector value = new java.util.Vector();
      while(iter.hasNext()){
        org.apache.axis2.om.OMAttribute attribute = (org.apache.axis2.om.OMAttribute)iter.next();
        double temp = Double.parseDouble(attribute.getValue().trim());
        if( sub < 0 ) {
        sub = temp;
       }
      else
      {
        sub = sub - temp;
     }
      //element.removeAttribute(attribute);
     }
      System.out.println(" Substract result "+sub+"  to element "+element.getNamespace().getName());
      element.setText(sub+"");
      //Secondly the OMElement should be detached from the current OMTree so that it can be attached
      //some other OM Tree. Once detached the OmTree will remove its connections to this OMElement.

      return element;
    }
    /* Method Multiplication  ,Takens in OMElement of this format
     */
    public OMElement multiplication(OMElement element) throws XMLStreamException {
      //Praparing the OMElement so that it can be attached to another OM Tree.
      //First the OMElement should be completely build in case it is not fully built and still
      //some of the xml is in the stream.

      element.build();
      element.detach();
      java.util.Iterator  iter = element.getAttributes();
      double mul = 1;
      while(iter.hasNext()){
        org.apache.axis2.om.OMAttribute attribute = (org.apache.axis2.om.OMAttribute)iter.next();
        double temp = Double.parseDouble(attribute.getValue().trim());
        mul*=temp;
      //element.removeAttribute(attribute);
       }
      System.out.println("  Multiplication result "+mul+"  to element "+element.getNamespace().getName());
      element.setText(mul+"");
      //Secondly the OMElement should be detached from the current OMTree so that it can be attached
      //some other OM Tree. Once detached the OmTree will remove its connections to this OMElement.
      return element;
    }
    /* Method Division  ,Takens in OMElement of this format
     */
    public OMElement division(OMElement element) throws XMLStreamException {
      //Praparing the OMElement so that it can be attached to another OM Tree.
      //First the OMElement should be completely build in case it is not fully built and still
      //some of the xml is in the stream.
      element.build();
      element.detach();
      java.util.Iterator  iter = element.getAttributes();
      float div = 1;
      while(iter.hasNext()){
        org.apache.axis2.om.OMAttribute attribute = (org.apache.axis2.om.OMAttribute)iter.next();
        double temp = Double.parseDouble(attribute.getValue().trim());
        div=(float)temp/div;
      //element.removeAttribute(attribute);
       }
        div = 1/div;
      System.out.println("Division result "+div+"  to element "+element.getNamespace().getName());
      element.setText(div+"");
      //Secondly the OMElement should be detached from the current OMTree so that it can be attached
      //some other OM Tree. Once detached the OmTree will remove its connections to this OMElement.
      return element;
    }
}
